'-------------------------------------------------------------------
'       MAZIST - by Geoff Camp, 2021 - v0.99
'-------------------------------------------------------------------
option base 0
option default integer
mode 1,8
load gif "Angry_papa.gif"

page write 2
load bmp "MazeSaveMenu.bmp"
page write 0
framebuffer create 1600, 1200
dim w1(99,69),v1(99,69)
dim MS_x(9),MS_y(9)' load/save boxes co-ords
dim i,j' for loop counters
dim x,y' general throw-away integers
dim v,h' maze size
dim xx' maze entry
dim q,s',r used in maze generation
dim MS_num' maze save/load number
dim lm,mload' load maze flag
dim quit' general 'quit a routine' flag
dim done' routine done flag
dim Info' Info/Instructions flag
dim win' solved maze flag
dim Restart' restart maze from entry flag
dim Mice' print solution select flag
dim MazeEnd' exit maze y co-ord
dim sx,sy' gui cursor position
dim tt' time/timer
dim hour$,mnit$,sec$' timer coveter to H.M.S.
dim cp,TrailPix' maze & trail pixel colours
dim c' maze node counter ***
dim dh,dv' maze print offsets for centering maze on screen
dim vx,vy' print maze x/y co-ords
dim kd' keydown value ***
dim md' flashing graphiv cursor counter
dim bx,by,bx2,by2,bt,bc1,bc2,bf' variables for block routine
dim pointer' select maze size red/green line
dim a$' general string variable  - read/write data - key presses
dim n,r,g,b' flash maze and define colours
dim zdh,zdv' converted dh/dv for printing zoomed maze
dim zoom_y' placement of zoomed screen on maze screen
dim zsx,zsy' plater place in zoomed screen
dim oldsx,oldsy' stop zoomed flicker - defines if a player has moved
dim x1,y1,oldx,oldy' used in mouse solve with show trail

restore MS_Data
for i=1 to 9
read MS_x(i), MS_y(i)
next i
  
const cBlack=0,cLtGreen=1,cYellow=2,cOrange=3,cRed=4,cRose=5,cMagenta=6,cViolet=7
const cBlue=8,cAzure=9,cCyan=10,cAqua=11,cGreen=12,cWhite=13,cGrey=14,cDkGrey=15
const cMaroon=16,cDkBlue=17
' const p0_add=mm.info(page address 0)
const Solve_Speed=50' Sets speed of movement through the maze . <40 hard to move only 1 spot
const SpeedMeece=50' Sets speed of mouse solution with show trail so it can be seen

h=50:v=35  
MS_num=1

page write 1
cls
load gif "mazist.gif",32,0
text 400,190,"By: Geoff Camp, 2021",c,4,2,map(cRed)
page write 0
  
gui cursor load "mazist.cur"
font 4

for i=0 to 800:page scroll 0,-1,0,map(cBlack):BLIT i,0,799,0,1,600,1:next i' scroll angy smurf off

Palette

' main programme loop

do
  quit=0
  IntroScreen
  if lm=1 then MazeLoad
  if lm=1 and mload=1 goto loaded
  if lm=1 and quit=1 then continue do ' quit maze load so start loop again
  GetMazeSize
  if quit=1 then continue do 'start again
  GenerateMaze
  PrntMaze
Loaded: SolveMaze
  PressSpace
loop

end

' print maze to graphics screen

sub PrntMaze
cls
colour map(cLtGreen)
dh=(99-h)*4
dv=(69-v)*4
for i=1 to h
  vx=(i*4)-4
  if i=xx then box vx*2+dh,0+dv,4,4,2 else box vx*2+dh,0+dv,8,4,2
next i
box (vx+4)*2+dh,0+dv,4,4,2

for j=1 to v
  vy=(4*j)-2
  box 0+dh,vy*2+dv,4,4,2
  for i=1 to h
    vx=4*i-2
    if v1(i,j)<2 then box (vx+2)*2+dh,vy*2+dv,4,4,2
  next i
    
  vy2=vy+2
  for i=1 to h
    vx=4*i-4
    if v1(i,j)=0 or v1(i,j)=2 then box vx*2+dh,vy2*2+dv,8,4,2 else box vx*2+dh,vy2*2+dv,4,4,2
  next i
    
  box (vx+4)*2+dh,vy2*2+dv,4,4,2
next j

text 400,566,"|ARROW KEYS| to move +|CTRL| to mark a trail or +|ALT| to remove a trail",c,1,1,rgb(255,127,0)
text 400,582,"|R| restart maze |M| mouse solve |F| fast solve |S| save maze |Q| Quit maze",c,1,1,rgb(227,100,0)
page copy 0 to 4
Zoom_PrntMaze' print double size maze to framebuffer

end sub

' get maze dimension - horizontal 10-99, vertical 10-69

sub GetMazeSize

page copy 1 to 0
done=0
quit=0
text 400,240,"Select Maze Size",c,4,2,map(cLtGreen)
text 400,300,"Use |ARROW KEYS| to increase/decrease size",c,4,,map(cOrange)
text 400,320,"Press |SPACE| to begin maze generation or |Q| to quit to title",c,4,,map(cOrange)
block 245,445,305,497,7,map(cWhite),map(cDkGrey)
block 495,445,555,497,7,map(cWhite),map(cDkGrey)
font 4,2:colour map(cOrange):print @(220,458)chr$(149):print @(310,458)chr$(148)
print @(470,458)chr$(147):print @(560,458)chr$(146)
font 4
text 277,390,"Horizontal",c,,,map(cRed)
text 527,390,"Vertical",c,,,map(cRed)
text 277,410,"(10-99)",c,,,map(cMagenta)
text 527,410,"(10-69)",c,,,map(cMagenta)
Text 400,570,"Tiny     Small     Medium     Large     Big     Gigantic     Brutal     WOW!",c,,,map(cYellow)

do
  kd=keydown(0)
loop until kd=0

do
pointer=int((h*v)/8.54)
line 0,596,pointer,596,4,map(cRed)
line pointer,596,800,596,4,map(cGreen)
font 4,2
colour map(cGreen)
print @(257,457)right$(str$(h),2);
print @(507,457)right$(str$(v),2);

for i=1 to 6
  kd=keydown(i)
  select case kd
    case 130
      inc h,-(h>10)
    case 131
      inc h,(h<99)
    case 129
      inc v,-(v>10)
    case 128
      inc v,(v<69)
    case 32
      done=1
    case 81,113
      quit=1
  end select
next i

pause 30
loop until (done+quit)>0
font 4,1
end sub

' intro screen

sub IntroScreen

Intro:page copy 1 to 0
colour map(cGreen):text 400,240,"Maze routine based on 'Maze' found in 'Basic Computer Games'",c
text 400,256,"edited by David H Ahl, 1973.",c
text 400,272,"Grapics interface, sound, solving, loading/saving routines, etc by myself",c
colour map(cOrange):text 200,320,"Control keys during maze solve:"
colour map(cCyan):print @(200,350)"|";:colour map(cRed):print "Arrow Keys";:colour map(cCyan):print "| move cursor towards exit"
print @(220,370)"+ |";:colour map(cRed):print "CTRL";:colour map(cCyan):print"| mark a trail";
print ", or + |";:colour map(cRed):print "ALT";:colour map(cCyan):print "| to remove a trail"
print @(200,390)"|";:colour map(cRed):print "Q";:colour map(cCyan):print "| quit to menu"
print @(200,410)"|";:colour map(cRed):print "S";:colour map(cCyan):print "| Save maze to disc with progress"
print @(200,430)"|";:colour map(cRed):print "M";:colour map(cCyan):print "| Mouse solve the maze!"
print @(200,450)"|";:colour map(cRed):print "F";:colour map(cCyan):print "| Fast solve - no mouse tracks!"
print @(200,470)"|";:colour map(cRed):print "R";:colour map(cCyan):print "| Restart the maze at entry"
colour map(cYellow):text 400,500,"Select from the following to continue....",c
colour map(cWhite):print @(250,520)"|";:colour map(cRed):print "I";:colour map(cWhite):print "| for info/instructions",
print @(250,540)"|";:colour map(cRed):print "L";:colour map(cWhite):print "| to load saved maze"
print @(250,560)"|";:colour map(cRed):print "SPACE";:colour map(cWhite):print "| for new maze"
print @(250,580)"|";:colour map(cRed):print "Q";:colour map(cWhite):print "| to quit";
text 800,590,"Vers 0.95",r,7,,map(cGrey)
x=0:y=0:lm=0:Info=0:quit=0
do
  a$=ucase$(inkey$):if a$="Q" then CLS:text 400,300,"BYE",cm,4,12,map(cMagenta):pause 500:END
  if a$="L" then lm=1:exit do
  inc x:inc y
  if x=4 then x=0
  if y=15001 then blit 0,0,0,0,800,184,1,x:y=0
  if a$="I" then Info=1:exit do

loop until a$=" " or Info=1
if Info=1 then Instructions:goto Intro

end sub

' solve maze

sub SolveMaze

SolveStart:
if lm=0 then sx=(xx*8)-4+dh:sy=dv:timer=0'reset if not a loaded maze
MazeEnd=(v*8)+dv
quit=0:win=0:restart=0:Mice=0' reset flags
gui cursor on 2,sx,sy
settick 200,flsh

zoom_y=310
zoom=0'change to =0 as a flag

do
  kd=keydown(1)
  if kd=130 and pixel(sx-4,sy)<>cp then sx=sx-4
  if kd=131 and pixel(sx+4,sy)<>cp then sx=sx+4
  if kd=128 and pixel(sx,sy-4)<>cp and sy<>dv then sy=sy-4
  if kd=129 and pixel(sx,sy+4)<>cp then sy=sy+4
  if kd=81 or kd=113 then quit=1' Quit
  if kd=82 or kd=114 then Restart=1' Restart
  if kd=77 or kd=109 then Mice=1:ShowMice=1' Mouse solve
  if kd=70 or kd=102 then Mice=1:ShowMice=0' Fast mouse solve
  if sy=MazeEnd then win=1
  if (keydown(7) and 34)>0 then' mark trail on both screens
    box sx,sy,4,4,2,map(cAzure)
    page write framebuffer
    box sx*2,sy*2,8,8,4,map(cAzure)
    page write 0
  endif
  if (keydown(7) and 17)>0 then' unmark trail on both screens
    box sx,sy,4,4,2,map(cBlack)
    page write framebuffer
    box sx*2,sy*2,8,8,4,map(cMaroon)
    page write 0
  endif 
  if kd=83 or kd=115 then' Save
    settick 0,flsh
    gui cursor off
    MazeSave
    gui cursor on 2,sx,sy
    settick 200,flsh
    quit=0
  endif 

  if kd=90 or kd=122 then' Zoom on/off
    zoom=(zoom<=0)' flip between 0 and 1
    pause 150' try to prevent the double click
    if zoom=0 then 
      blit 274,zoom_y-1,274,zoom_y-1,252,252,4
    endif  
    zoom_y=310' decide where to put the zoomed maze
    if sy>276 then
      zoom_y=1
    endif
    if zoom=1 then
      box 275,zoom_y,250,250,1,map(cMaroon),map(cMaroon)
    endif
   endif

 tt=timer/1000
  hour$=str$(int(tt/60/60) mod 24,2,0,"0")
  mnit$=str$(int(tt/60) mod 60,2,0,"0")
  sec$=str$(tt mod 60,2,0,"0")
  text 790,590,hour$+":"+mnit$+":"+sec$,r,7,1,map(cWhite)
  
  gui cursor sx,sy

' zoom window to screen
  if zoom=1 then
    zsx=sx*2-125:zsy=sy*2-125
    ' blank out area of screen if zoom off framebuffer AND player moved
    ' top bottom left and right
    if zsy<0 and oldsy<>sy then
      box 275,zoom_y,250,125,1,map(cMaroon),map(cMaroon)
    endif
    if zsx<0 and oldsx<>sx then
     box 275,zoom_y,125,250,1,map(cMaroon),map(cMaroon)
    endif
    if zsy>851 and oldsy<>sy then ' olny draw in player moved or start of maze
      box 275,zoom_y+125,250,125,1,map(cMaroon),map(cMaroon)
    endif
    if zsx>1331 and oldsx<>sx then
     box 275+125,zoom_y,125,250,1,map(cMaroon),map(cMaroon)
    endif
' now blit area of frame buffer - swap top/bottom if cursor nearing zoom area
    blit zsx,zsy,275,zoom_y,250,250,framebuffer
    box 400,zoom_y+125,8,8,4,map(cRed)
    box 274,zoom_y-1,252,252,1,map(cYellow)
      if oldsy=292 and sy=296 then 
      blit 274,zoom_y-1,274,zoom_y-1,252,252,4
      zoom_y=1
        else if oldsy=268 and sy=264 then
        blit 274,zoom_y-1,274,zoom_y-1,252,252,4
        zoom_y=310
      endif
    endif
  endif

oldsy=sy ' flags for player movement in maze
oldsx=sx

  pause Solve_Speed' slow movement down a bit
loop until win+quit+Restart+Mice>0

settick 0,flsh
gui cursor off

if zoom=1 then blit 274,zoom_y-1,274,zoom_y-1,252,252,4
if win=1 then WinFlash
if restart=1 goto SolveStart
if Mice=1 then MouseSolve

end sub

' win so print rnd congrats message and flash maze - add sound

sub WinFlash

text 400,564,space$(78),c,4,2
restore Congrats
read x

for i=1 to int(rnd*x)+1
  read a$
next i

text 400,564,a$,c,4,1,map(cLtGreen)
text 400,582,"Solved in "+hour$+" Hours, "+mnit$+" Minutes and "+sec$+" Seconds",c,4,1,Map(cWhite)
play wav "clap.wav"

for i=1 to 150
  map(cLtGreen)=rgb(rnd*255,rnd*255,rnd*255)
  map set
  pause 60
next i

restore c1
read n,r,g,b
map(cLtGreen)=rgb(r,g,b)
map set
text 400,564,space$(78),c,4,2

end sub

' generate maze

sub GenerateMaze

math set 0,w1()
math set 0,v1()
q=0
z=0
page copy 1 to 0
text 400,566,"G E N E R A T I N G   M A Z E",c,4,2,map(cRed)
x=int(rnd*h)+1
xx=x
c=1
w1(x,1)=c
inc c
r=x
s=1
PrntC
goto Gen5

Gen1: if r<>h goto Gen3
if s<>v goto Gen2
r=1:s=1
goto Gen4

Gen2: r=1
inc s
goto Gen4

Gen3: inc r

Gen4: if w1(r,s)=0 goto Gen1

Gen5: if r=1 goto Gen18
if w1(r-1,s)>0 goto Gen18
if s=1 goto Gen10
if w1(r,s-1)<>0 goto Gen10
if r=h goto Gen6
if w1(r+1,s)>0 goto Gen6
x=int(rnd*3)+1
select case x
  Case 1
    goto Gen33
  case 2
    goto Gen34
  case 3
    goto Gen35
end select

Gen6: if s<>v goto Gen7
if z=1 goto Gen9
q=1
goto Gen8

Gen7: if w1(r,s+1)>0 goto Gen9

Gen8: x=int(rnd*3)+1
select case x
  Case 1
    goto Gen33
  case 2
    goto Gen34
  case 3
    goto Gen38
end select

Gen9: x=int(rnd*2)+1
select case x
  Case 1
    goto Gen33
  case 2
    goto Gen34
end select

Gen10: if r=h goto Gen14
if w1(r+1,s)>0 goto Gen14
if s<>v goto Gen11
if z=1 goto Gen13
q=1
goto Gen12

Gen11: if w1(r,s+1)>0 goto Gen13

Gen12: x=int(rnd*3)+1
select case x
  Case 1
    goto Gen33
  case 2
    goto Gen35
  case 3
    goto Gen38
end select

Gen13: x=int(rnd*2)+1
select case x
  Case 1
    goto Gen33
  case 2
    goto Gen35
end select

Gen14: if s<>v goto Gen15
if z=1 goto Gen17
q=1
goto Gen16

Gen15: if w1(r,s+1)>0 goto Gen17

Gen16: x=int(rnd*2)+1
select case x
  Case 1
    goto Gen33
  case 2
    goto Gen38
end select

Gen17: goto Gen33

Gen18: if s=1 goto Gen26
if w1(r,s-1)>0 goto Gen26
if r=h goto Gen22
if w1(r+1,s)>0 goto Gen22
if s<>v goto Gen19
if z=1 goto Gen21
q=1
goto Gen20

Gen19: if w1(r,s+1)>0 goto Gen21

Gen20: x=int(rnd*3)+1
select case x
  Case 1
    goto Gen34
  case 2
    goto Gen35
  case 3
    goto Gen38
end select

Gen21: x=int(rnd*2)+1
select case x
  Case 1
    goto Gen34
  case 2
    goto Gen35
end select

Gen22: if s<>v goto Gen23
if z=1 goto Gen25
q=1
goto Gen24

Gen23: if w1(r,s+1)>0 goto Gen25

Gen24: x=int(rnd*2)+1
select case x
  Case 1
    goto Gen34
  case 2
    goto Gen38
end select

Gen25: goto Gen34

Gen26: if r=h goto Gen30
if w1(r+1,s)>0 goto Gen30
if s<>v goto Gen27
if z=1 goto Gen29
q=1
goto Gen28

Gen27: if w1(r,s+1)>0 goto Gen29

Gen28: x=int(rnd*2)+1
select case x
  Case 1
    goto Gen35
  case 2
    goto Gen38
end select

Gen29: goto Gen35

Gen30: if s<>v goto Gen31
if z=1 goto Gen1
q=1
goto Gen32

Gen31: if w1(r,s+1)>0 goto Gen1

Gen32: goto Gen38

Gen33: w1(r-1,s)=1:inc c:v1(r-1,s)=2:inc r,-1
if c=h*v+1 goto Gen43
q=0
goto Gen5

Gen34: w1(r,s-1)=1:inc c:v1(r,s-1)=1:inc s,-1
if c=h*v+1 goto Gen43
q=0
goto Gen5

Gen35: w1(r+1,s)=1:inc c
if v1(r,s)=0 goto Gen36
v1(r,s)=3
goto Gen37

Gen36: v1(r,s)=2

Gen37: inc r
if c=h*v+1 goto Gen43
q=0
goto Gen18

Gen38: if q=1 goto Gen41
w1(r,s+1)=1
inc c
PrntC
if v1(r,s)=0 goto Gen39
v1(r,s)=3
goto Gen40

Gen39: v1(r,s)=1

Gen40: inc s
if c=h*v+1 goto Gen43
goto Gen5

Gen41: z=1
if v1(r,s)=0 goto Gen42
v1(r,s)=3
q=0
goto Gen1

Gen42: v1(r,s)=1
q=0
r=1
s=1
goto Gen4

Gen43: if z=1 then exit sub
r=int(rnd*h)+1
s=v
v1(r,s)=v1(r,s)+1

end sub

' Save a maze

sub MazeSave

tt=timer

page copy 4 to 3 ' save maze screen for shrinking ' don't use 0 - might be zoomed
page copy 2 to 0 ' display SaveMaze menu screen
text 400,566,"SAVE MAZE - Press 1-9 to select Save position",c,4,1,map(cCyan)
text 400,582,"|SPACE| to begin save, |Q| to exit without saving",c,4,1,map(cCyan)

quit=0
msave=0
MS_num=1
box MS_x(MS_num)-2,MS_y(MS_num)-2,203,143,2,map(cRed)

do
kd=keydown(1)
  select case kd
    case 49 to 57
      box MS_x(MS_num)-2,MS_y(MS_num)-2,203,143,2,map(255,255,255)
      MS_num=kd-48
      box MS_x(MS_num)-2,MS_y(MS_num)-2,203,143,2,map(cRed)
    case 81,113
      quit=1
    case 32
      msave=1
  end select
loop until quit+msave>0
if quit=1 then
  page copy 4 to 0
  exit sub
endif

text 400,566,"Making mini-maze and saving data",c,4,2,map(cRed)
' Shrink the maze and save screen and data - pity it's a 24 bit bmp file

box MS_x(MS_num)-2,MS_y(MS_num)-2,203,143,2,map(255,255,255)

page write 3

for i=0 to 199
for j=0 to 139
if pixel(i*4,j*4)=cp then pixel i,j,rgb(127,255,0) else pixel i,j,map(cBlack)
next j
next i
page write 0
blit 0,0,MS_x(MS_num),MS_y(MS_num),199,139,3

m$="Maze_Save_"+str$(MS_num)+".maz"
open m$ for output as #1
for i=0 to 99:for j=0 to 69:print #1,v1(i,j):next:next
print #1,h:print #1,v:print #1,xx:print #1,sx:print #1,sy:print #1,tt
for i=0 to 800 step 4:for j=0 to 566 step 4
if pixel (i,j)=TrailPix then print #1,i:print #1,j
next:next
print #1,999 ' end of data
close #1

text 400,566,space$(32),c,4,2,map(cRed)
page copy 0 to 2
save image "MazeSaveMenu.bmp"

page copy 4 to 0
page display 0
page write 0
end sub

' Load a maze

sub MazeLoad
page copy 2 to 0
MS_num=1
quit=0
getkey:mload=0

box MS_x(MS_num)-2,MS_y(MS_num)-2,203,143,2,map(cRed)
text 400,566,"LOAD MAZE - Press 1-9 to select Maze to load",c,4,1,map(cCyan)
text 400,582,"|SPACE| to begin load, |Q| to exit without saving",c,4,1,map(cCyan)

do
kd=keydown(1)
  select case kd
    case 49 to 57
      box MS_x(MS_num)-2,MS_y(MS_num)-2,203,143,2,map(255,255,255)
      MS_num=kd-48
      box MS_x(MS_num)-2,MS_y(MS_num)-2,203,143,2,map(cRed)
    case 81,113
      quit=1
    case 32
      mload=1
  end select
loop until quit+mload>0
if quit=1 then exit sub

box MS_x(MS_num)-2,MS_y(MS_num)-2,203,143,2,map(255,255,255)

m$="Maze_Save_"+str$(MS_num)+".maz"
if dir$(m$,FILE)="" goto getkey
lm=1
open m$ for input as #1
for i=0 to 99:for j=0 to 69:line input #1,a$:v1(i,j)=val(a$):next:next
line input #1,a$:h=val(a$)
line input #1,a$:v=val(a$)
line input #1,a$:xx=val(a$)
line input #1,a$:sx=val(a$)
line input #1,a$:sy=val(a$)
line input #1,a$:timer=val(a$)
PrntMaze
do
line input #1,a$
if val(a$)=999 then exit do
line input #1,a2$
box val(a$),val(a2$),4,4,2,map(cAzure)
loop
close #1

end sub

' Mouse Solve routine

sub MouseSolve

text 400,566,"C A L C U L A T I N G   S O L U T I O N",c,4,2,map(cRed)
s=xx
pp=0
math set 0,w1()
for i=1 to h
  for j=1 to v
    if j=1 goto MSolve1
    if v1(i,j-1)=1 or v1(i,j-1)=3 then w1(i,j)=w1(i,j)+1
MSolve1: if j=v goto MSolve2
      if v1(i,j)=1 or v1(i,j)=3 then w1(i,j)=w1(i,j)+2
MSolve2: if i=h goto MSolve3
      if v1(i,j)=2 or v1(i,j)=3 then w1(i,j)=w1(i,j)+4
Msolve3: if i=1 then continue for 'goto MSolve4
      if v1(i-1,j)=2 or v1(i-1,j)=3 then w1(i,j)=w1(i,j)+8
Msolve4: next j
   next i

for i=1 to h
  if v1(i,v)=1 or v1(i,v)=3 then w1(i,v)=w1(i,v)+2:e=i
next i
y=1:x=s
oldx=x:oldy=y
v1(x,y)=v1(x,y)+4
MSolve5:if ShowMice=1 then Meece

if y=v and x=e goto MousePrnt
MSolve6: if (w1(x,y) and 2)<>0 goto MSolve10
MSolve7: if (w1(x,y) and 4)<>0 goto MSolve12
MSolve8: if (w1(x,y) and 8)<>0 goto MSolve13
MSolve9: if (w1(x,y) and 1)<>0 goto MSolve14
goto MSolve5

MSolve10: if (v1(x,y+1)>3) and ((w1(x,y) and 13)=0) goto MSolve11
if v1(x,y+1)>3 goto MSolve7
inc y:v1(x,y)=v1(x,y)+4:goto MSolve5

MSolve11: v1(x,y)=v1(x,y)-4:w1(x,y)=(w1(x,y) and 13):inc y:w1(x,y)=(w1(x,y) and 14)
goto MSolve5

MSolve12: if (v1(x+1,y)>3) and ((w1(x,y) and 11)=0) goto MSolve16
if v1(x+1,y)>3 goto MSolve8
inc x:v1(x,y)=v1(x,y)+4:goto MSolve5

MSolve16: v1(x,y)=v1(x,y)-4:w1(x,y)=(w1(x,y) and 11):inc x:w1(x,y)=(w1(x,y) and 7)
goto MSolve5

MSolve13: if (v1(x-1,y)>3) and ((w1(x,y) and 7)=0) goto MSolve17
if v1(x-1,y)>3 goto MSolve9
inc x,-1:v1(x,y)=v1(x,y)+4:goto MSolve5

MSolve17: v1(x,y)=v1(x,y)-4:w1(x,y)=(w1(x,y) and 7):inc x,-1:w1(x,y)=(w1(x,y) and 11)
goto MSolve5

MSolve14: if (v1(x,y-1)>3) and ((w1(x,y) and 14)=0) goto MSolve15
if v1(x,y-1)>3 goto MSolve6
inc y,-1:v1(x,y)=v1(x,y)+4:goto MSolve5

MSolve15: v1(x,y)=v1(x,y)-4:w1(x,y)=(w1(x,y) and 14):inc y,-1:w1(x,y)=(w1(x,y) and 13)
goto MSolve5

' Mouse solve - print final solution

MousePrnt: colour map(cRed):vx=(xx*4)-4
box vx*2+dh+4,dv,4,4,2
for j=1 to v:vy=(j*4)-2
  for i=1 to h:vx=(i*4)-2
    if v1(i,j)>3 then z=v1(i,j)-4 else z=v1(i,j)
    if z<2 goto MP3600
    if z<>v1(i,j) then box vx*2+dh,vy*2+dv,8,4,2
    continue for
MP3600: if z<>v1(i,j) then box vx*2+dh,vy*2+dv,4,4,2
  next i
vy2=vy+2
  for i=1 to h:vx=(i*4)-2
    if v1(i,j)>3 then z=v1(i,j)-4 else Z=V1(I,J)
    if z=0 OR Z=2 then continue for
    if z<>v1(i,j) and j=v then box vx*2+dh,vy2*2+dv,4,4,2
    if j=v then continue for
    if z<>v1(i,j) and v1(i,j+1)>3 then box vx*2+dh,vy2*2+dv,4,4,2
  next i
next j

end sub

' Manual, About, Info, Read-Me, etc

sub Instructions

cls
page copy 1 to 0
colour map(cCyan)
text 400,232,"Maze generation routine is based on 'Maze' from 'More Basic",c
text 400,248,"Compuer Games', edited by David H Ahl.",c
text 400,280,"Mazist is a maze generation program that prints the maze to the",c
text 400,296,"graphics screen. The maze can range from 10x10 cells to 99x69",c
text 400,312,"cells. The maze can be solved on screen, saved",c
text 400,328,"(and later loaded) or the escape route (Mouse Solve) can be",c
text 400,344,"calculated and shown on screen.",c
text 400,376,"CMM2 Mazist is also based on MAZIST that I wrote in STOS for the",c
text 400,392,"Atari ST way back in the day and also on Mazist 2 written for the",c
text 400,408,"Amstrad CPC mainly in z80 Machine Code in 2020.",c
text 400,440,"MAZE GENERATION - bigger maze = longer time to generate.",c
text 400,456,"A longer time is still a short time on the CMM2!",c
text 400,488,"MAZE SOLVE - Use the |Arrow Keys| to move around the maze to the exit.",c
text 400,504,"Press |CTRL| to mark a spot or to leave a trail behind you.",c
text 400,520,"Press |ALT| to remove marks. Usefull for solving large mazes over",c
text 400,536,"several sessions. Press |R| to restart maze at entry point.",c
PressSpace
page copy 1 to 0
colour map(cCyan)
text 400,232,"Press |Q| to quit to the main menu or |S| to save the maze.",c
text 400,264,"SAVE MAZE / LOAD MAZE: Up to 9 mazes can be saved for later loading.",c
text 400,280,"Select save/load position by pressing 1-9 keys. A red box will",c
text 400,296,"be drawn around the chosen position. Press |SPACE| to start",c
text 400,312,"save/load routine. A save will overwrite a previously saved maze.",c
text 400,328,"Saving a mazes preserves you cursor position, time taken in the",c
text 400,344,"maze and any trails that you have marked in the maze. Loading a",c
text 400,360,"maze is very quick but saving takes time to save the 24bit BPM file",c
text 400,376,"containing the mini mazes. Press |Q| to abort loading or saving.",c
text 400,392,"Mazist comes with 9 saved mazes - feel free to overwrite them!",c
text 400,424,"MOUSE SOLVE - Press |M| while solving a maze. Time taken to display",c
text 400,440,"the solution depends on the maze size & complexity. |Q| will exit to",c
text 400,456,"a faster solve. Press |F| for a fast solve with no mouse tracks shown.",c
text 400,488,"Press |SPACE| once you've admired the solution to return to the main menu.",c
text 400,520,"This is my first outing with the CMM2 - forgive any sloppy programming.",c
text 400,536,"Contact me at goksteroo@gmail.com to offer assistance/advice/etc.",c
PressSpace

end sub

' Space to continue

sub PressSpace

text 400,566,"       Press |SPACE| to continue       ",c,4,2,map(cRed)
do
   a$=inkey$
loop until a$=" "

end sub

' Print value of 'c' as maze is made

sub PrntC

text 400,360,str$(c)+" nodes of "+str$(h*v),c,4,2,map(cWhite)

end sub

' Draw a shadowed box: bx,by=left upper     bx2,by2=right lower
' bt=wall thickness   bc1=top & left colour  bc2=bottom & right colour
' bf=fill colour

sub block bx,by,bx2,by2,bt,bc1,bc2,bf

for bc=0 to bt
  line bx2-bc,by2-bc,bx+bc,by2-bc,,bc2
  line bx+bc,by2-bc,bx+bc,by+bc,,bc1
  line bx+bc,by+bc,bx2-bc,by+bc,,bc1
  line bx2-bc,by+bc,bx2-bc,by2-bc,,bc2
next bc
bf1=(bx+bx2)/2
bf2=(by+by2)/2
pixel fill bf1,bf2,bf

end sub

' Flash Graphics Cursor

sub flsh

inc md
if (md mod 2)=1 then
   gui cursor show
 else
   gui cursor hide
endif

end sub

' set palette

sub Palette

restore c0
for i=0 to 17
  read n,r,g,b
  map(n)=rgb(r,g,b)
next i
map set
pixel 0,0,map(cLtGreen)
cp=pixel(0,0)' maze wall pixel value
pixel 0,0,map(cAzure)
TrailPix=pixel(0,0)' maze trail pixel value
end sub
  
c0: data 0,0,0,0' black
c1: data 1,127,255,0' LtGreen
data 2,255,255,0' yellow
data 3,255,127,0' orange
data 4,255,0,0' red
data 5,255,0,127' rose
data 6,255,0,255' magenta
data 7,127,0,255' violet
data 8,0,0,255' blue
data 9,0,127,255' azure
data 10,0,255,255' cyan
data 11,0,255,127' aquamarine
data 12,0,255,0' green
data 13,255,255,255' white
data 14,150,150,150' light grey
data 15,75,75,75' dark grey
data 16,100,0,0' Maroon
data 17,0,0,75' DkBlue

Congrats: data 20,"WOOHOOO...YOU DID IT!"' numer ofdata to read... sayings
data "CONGRATULATIONS"
data "EAT MY SHORTS - COWABUNGA DUDE!"
data "HISTORIC SOUTION"
data "IMPRESSIVELY DONE"
data "I'M IMPRESSED BEYOND BELIEF"
data "AMAZING JOB - WAS MAGIC INVOLVED?"
data "THAT WAS JUST TOO EASY - TRY BIGGER"
data "OOOOOHHHH..... OUTSTANDING!"
data "YOU HAVE WONDERFUL MAZE VISION"
data "MUCH BETTER THAN THE MAGNIFICENT 7"
data "YOU MADE THE MAZIST HALL OF FAME"
data "THE 'ROCK' SALUTES YOU"
data "ONE GOOD TURN DESERVES ANOTHER"
data "YOU HAVE DEFEATED MAZIST"
data "YOU CAN'T BUY THAT FOR A DOLLAR"
data "YOU WIN - THE MAZIST IS SAD NOW"
data "WHO HIT YOU WITH A MAZIST STICK?"
data "I LIKE BIG MAZES AND I CAN NOT LIE"
data "YOU HAVE CAUSED GREAT WONDER"

' Screen co-ords for save mini-mazes

MS_data:
data 50,45,300,45,550,45
data 50,230,300,230,550,230
data 50,415,300,415,550,415

' Mouse solve - show progress

sub Meece

kd=keydown(1)
if kd=81 or kd=113 then 
  ShowMice=0
  exit sub
end if
x1=x*8+dh-4:y1=y*8+dv-4
box x1,y1,4,4,2,map(cRed)
if pixel(x1+4,y1)<>cp then box x1+4,y1,4,4,2,map(cRed)
if pixel(x1,y1+4)<>cp then box x1,y1+4,4,4,2,map(cRed)
if pixel(x1+4,y1+4)<>cp then box x1+4,y1+4,4,4,2,map(cRed)
x1=oldx*8+dh-4:y1=oldy*8+dv-4

pause SpeedMeece' slow it all down a bit so solution can be seen

box x1,y1,4,4,2,map(cMaroon)
if pixel(x1+4,y1)<>cp then box x1+4,y1,4,4,2,map(cMaroon)
if pixel(x1,y1+4)<>cp then box x1,y1+4,4,4,2,map(cMaroon)
if pixel(x1+4,y1+4)<>cp then box x1+4,y1+4,4,4,2,map(cMaroon)
oldx=x:oldy=y

end sub

' print double sized maze to frame buffer for zooming in

sub Zoom_PrntMaze
page write framebuffer
cls map(cMaroon)
colour map(cYellow)
zdh=(99-h)*8
zdv=(69-v)*8
for i=1 to h
  vx=(i*8)-8
  if i=xx then box vx*2+zdh,0+zdv,8,8,4 else box vx*2+zdh,0+zdv,16,8,4
next i
box (vx+8)*2+zdh,0+zdv,8,8,4

for j=1 to v
  vy=(8*j)-4
  box 0+zdh,vy*2+zdv,8,8,4
  for i=1 to h
    vx=8*i-2
    if v1(i,j)<2 then box (vx+2)*2+zdh,vy*2+zdv,8,8,4
  next i
    
  vy2=vy+4
  for i=1 to h
    vx=8*i-8
    if v1(i,j)=0 or v1(i,j)=2 then box vx*2+zdh,vy2*2+zdv,16,8,4 else box vx*2+zdh,vy2*2+zdv,8,8,4
  next i
    
  box (vx+8)*2+zdh,vy2*2+zdv,8,8,4
next j
page write 0
end sub

